import cv2
import gym
import highway_env
from stable_baselines3 import DQN
import torch


frameSize = (640,280)
out = cv2.VideoWriter('video-DQN-baseline2-1.avi',cv2.VideoWriter_fourcc(*'DIVX'), 4, frameSize)


env = gym.make("highway-fast-v0")
env.configure({
    "screen_width": 640,
    "screen_height": 280
})

env.reset()

model = DQN('MlpPolicy', env,
              policy_kwargs=dict(net_arch=[256, 256]),
              learning_rate=5e-4,
              buffer_size=15000,
              learning_starts=200,
              batch_size=32,
              gamma=0.8,
              train_freq=1,
              gradient_steps=1,
              target_update_interval=50,
              verbose=1,
              tensorboard_log="highway_dqn/")
# uncomment the lines below if you want to train a new model

# model.learn(int(5e4))
# model.save("highway_dqn/model")

# print()
# print("Done Learning!!")
# print()


########## Load and test saved model##############
model = DQN.load("highway_dqn/model")
#while True:
for f in range(40):
  done = truncated = False
  obs, info = env.reset()
  while not (done or truncated):
    action, _states = model.predict(obs, deterministic=True)
    obs, reward, done, truncated, info = env.step(action.item(0))
    env.render()
    cur_frame = env.render(mode="rgb_array")
    out.write(cur_frame)

out.release()

print('DONE')