import gym
import numpy as np
import highway_env
from stable_baselines3 import DQN
from highway_env.vehicle.controller import ControlledVehicle
from highway_env.vehicle.kinematics import Performance, Logger, Vehicle
env = gym.make("racetrack-v1")
env.configure({
    'simulation_frequency':15,
    'policy_frequency':15,
    'other_vehicles': 1
    #"screen_width": 640,
    #"screen_height": 280
})
#obs, info = env.reset()
# print(obs.shape)

# model = DQN('MlpPolicy', env,
#             policy_kwargs=dict(net_arch=[256, 256]),
#             learning_rate=5e-4,
#             buffer_size=15000,
#             learning_starts=200,
#             batch_size=32,
#             gamma=0.8,
#             train_freq=1,
#             gradient_steps=1,
#             target_update_interval=50,
#             verbose=1,
#             tensorboard_log="highway_dqn/")
# # uncomment the lines below if you want to train a new model
#
#
# model.learn(int(5e3),progress_bar=False)
# model.save("highway_dqn/model")
#
# print()
# print("Done Learning!!")
# print()

# exit(0)
########## Load and test saved model##############
model = DQN.load("highway_dqn/model")
# while True:
perfm = Performance()
lolly = Logger()
for f in range(1):
    done = truncated = False
    obs, info = env.reset()
    reward = 1

    ego_car = env.controlled_vehicles[0]

    step_counter = 0
    while (not done) and ego_car.speed > 0.5 and step_counter < 500:
        action, _states = model.predict(obs, deterministic=True)
        obs, reward, done, truncated, info = env.step(action)
        step_counter += 1
        # print(isinstance(ego_car, ControlledVehicle), isinstance(ego_car, Vehicle))
        print(ego_car.lane_heading_difference, ego_car.speed, ego_car.lane)
        # print(step_counter)

        lolly.file(ego_car)
        env.render()

    # print(lolly.travel_distance)
    perfm.add_measurement(lolly)
    lolly.clear_log()

perfm.print_performance()
print('DONE')
