# drlcarsim
The folder 'DRLdriving' is a deep reinforcement learning library that expands on the "Highway Environment" library for Gym (Open AI), tailored to simulate autonomous driving scenarios. This modified library enhances the standard functionalities by introducing diverse vehicle behaviors and complex traffic situations to provide a comprehensive testing ground for autonomous driving technologies. The modifications include specialized features like "Complex City" which offers more dynamic road environments, and additional methods such as jerk calculations and lane highlighting, facilitating a more in-depth development and testing of autonomous vehicle algorithms.

'highway_env' folder contains the original "Highway Environment" library along with our additions (such as Complex City and new methods like jerk calculation or lane highlighting), for simulating more complex roads and traffic situations.

logs folder is intended for storing log information generated during the training process, which helps in analyzing model performance and debugging.

Python script files:

A2C_1.py, DDPG-3R.py, PPO2e5.py, Test_DDPG.py, TRPO 1e5.py are scripts implementing various deep reinforcement learning algorithms to train autonomous vehicles. Each script employs different algorithms like A2C (Advantage Actor-Critic), DDPG (Deep Deterministic Policy Gradient), PPO (Proximal Policy Optimization), TRPO, etc., to address the driving task at a roundabout intersection.
manual_control.py is likely a script that allows users to manually control a car in the simulation environment to test the environment's response and physical properties.